#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

# TODO: handle suites buster bookworm
NODES = $(wildcard /usr/share/boxer/bullseye/nodes/*.yml)

has_linux_amd64 = dharma hans huayruro-classmate parl-greens
has_linux_armhf = gateway
has_linux_i386 = lxp5
no_falkon = showmebox-qt
no_thunderbird = parl-desktop-all parl-desktop-eu parl-desktop-INDIA parl-desktop

# TODO: avoid linux-*/falkon/thunderbird where unavailable
ifeq (,$(filter $(DEB_HOST_ARCH), amd64))
NODES := $(filter-out $(foreach n,$(has_linux_amd64),%/$n.yml),$(NODES))
endif
ifeq (,$(filter $(DEB_HOST_ARCH), armhf))
NODES := $(filter-out $(foreach n,$(has_linux_armhf),%/$n.yml),$(NODES))
endif
ifeq (,$(filter $(DEB_HOST_ARCH), i386))
NODES := $(filter-out $(foreach n,$(has_linux_i386),%/$n.yml),$(NODES))
endif
ifneq (,$(filter $(DEB_HOST_ARCH), armhf))
NODES := $(filter-out $(foreach n,$(no_thunderbird),%/$n.yml),$(NODES))
endif
ifneq (,$(filter $(DEB_HOST_ARCH), ppc64el))
NODES := $(filter-out $(foreach n,$(no_falkon),%/$n.yml),$(NODES))
endif

all: $(NODES)

$(NODES):
	$(eval suite = /$(subst $() ,/,$(wordlist 1,4,$(subst /,$() ,$@))))
	$(eval node = $(basename $(notdir $@)))
	boxer compose --skel debian/tests/skel --datadir "$(suite)" "$(node)"
	bash ./script.sh
	rm preseed.cfg script.sh
